/********** GENERADOR DEL ALGORITMO NUMBERKN PARA EL ALGORITMO DE PERES DE DIMENSION N **************/

#include <stdio.h>
#include <string.h>

#define MAXCAR 256

/**
Este programa escribe el cdigo en C del algoritmo comprueba que, dado un grafo, todos sus vrtices estn 
contenidos en un Kn, siendo n la dimensin considerada para el problema.

Alberto Sols Encina. Copyright 2010. Histrico:
			13-12-2010: - Aadidos variables genricas y parmetros del algoritmo.
			13-12-2010: - Modificado para que devuelva una estructura definida como STRUCTKN
			27-12-2010: - Utilizacin de funciones de manipulacin del fichero propias de C.
			30-12-2010: - Tipo del main modificado a 'int' para devolver cdigo de error.
			30-12-2010: - Cdigo compilado correctamente.
			07-01-2011: - Extrada la definicin de la estructura StructInKn en "AlgPeres.h"
			07-01-2011: - Uso de DYNALLOC1 para almacenamiento dinmico de los arrays de la estructura.

**/

/** main devuelve -1 en caso de error, devuelve 0 en cualquier otro caso. **/
int main (int argc, int argv[]){
			/** Pasamos como argumento la dimensin con la que trabajar (dim)**/
			long dim =(long)atoi(argv[1]);
			//Varbiables del programa
			int contador=0;
			char s [MAXCAR];
			FILE* f;
			char variable_indice = 'a'; //usaremos como nombres de los arryas de la estructura usando de la a a la z (siguiendo el cdigo ASCII).

			//Apertura de fichero
			if ((f=fopen("numberKn.c","w")) == NULL){
				perror("Error al abrir el archivo f");
				return -1;}

		sprintf(s, "/** Calcula el nmero de Kn, con n la dimensin del problema, contenidos en g **/ \n");
		fputs(s, f);

		sprintf(s, "#include <stdio.h>\n#include \"AlgPeres.h\"\n\n");
		fputs(s,f);
			
		//-----------------------------------------------------------------------------------------
		sprintf(s,"STRUCTKN numberK%ld (graph* g, int m, int n){ \n\n", dim);
		fputs(s,f);
		
		 //*************************** Declaracion de variables ***********************************
		
		//Deben declararse por tanto el mismo nmero de variables como dimension
		 for(contador=0;contador<dim;contador++){
			sprintf(s,"int var%d;\n", contador);
			fputs(s, f);
		 }
		
		 //Deben declararse tantos setwords como nmero de 'while' menos el ltimo que aparecen y que almacenan los vecinos adyacentes
		 for(contador=0;contador<dim-1;contador++){
			sprintf(s,"setword ady%d;\n",contador);
			fputs(s, f);
		 }		
		
		 //Inicializacin de los valores de la estructura
		 sprintf(s,"\nSTRUCTKN str;\nstr = (STRUCTKN) malloc (sizeof(struct StructInKn));\nstr->nKn = 0;\n\n");
		 fputs(s, f);
		 
		 //Alojamiento en memoria de los arrays Tx.
		 variable_indice = 'a';
		 for(contador = 0; contador < dim; contador++){
			sprintf(s,"DYNALLOC1(int,str->T%c,str->T%c_sz,m,\"malloc\");\n",variable_indice,variable_indice);
			fputs(s, f);
			variable_indice++;
		 }

				
		//*****************************************************************************************
		
		//Raz del anidamiento de bucles
		sprintf(s,"\nfor (var0=0;var0<n-%ld+1;var0++){\n ady0 = g[var0] & BITMASK(var0);\n",dim);
		fputs(s, f);
		
		//Bucle 'for' para generar el conjunto de bucles anidados
		for(contador=1;contador<=dim-3;contador++){
			sprintf(s, "while(ady%d){\n TAKEBIT(var%d,ady%d);\n ady%d=g[var%d]&BITMASK(var%d);\n",contador-1,contador,contador-1,contador,contador-1,contador-1);
			fputs(s, f);
		}
		
		sprintf(s,"while(ady%ld){\n\t TAKEBIT(var%ld,ady%ld);\n\t ady%ld = g[var%ld]&ady%d;\n",dim-3,dim-2,dim-3,dim-2,dim-2,0);
		fputs(s, f);
		
		sprintf(s,"while(ady%ld){\n\t TAKEBIT(var%ld,ady%ld);\n",dim-2,dim-1,dim-2);
		fputs(s, f);
		
		variable_indice='a';
		for(contador=0;contador<dim;contador++){
			sprintf(s,"\tstr->T%c[str->nKn]=var%d;\n",variable_indice,contador);
			fputs(s, f);
			variable_indice++;
		}
		
		sprintf(s,"\tstr->nKn= str->nKn+1;\n");
		fputs(s, f);
		
		for(contador=0;contador<dim;contador++){
			sprintf(s,"}\n");
			fputs(s, f);
		}
		
		sprintf(s,"return str;\n}");
		fputs(s, f);
				
		fclose(f);
return 0;
}
